// ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Example.h"
#include "HOcrInterface.h"
#include "Display_IMG.h"
#include "ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char* getMAC(char *mac_addr, int str_max_size);

Display_IMG DI;
Display_IMG FI;
Display_IMG RI;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
	m_h = 0;
	m_w = 0;
	m_x = 0;
	m_y = 0;
	m_Threshold = 0;
	m_CharSet = _T("");
	m_25chk = FALSE;
	m_39chk = FALSE;
	m_25i = FALSE;
	m_39 = FALSE;
	m_128 = FALSE;
	m_93 = FALSE;
	m_ean13 = FALSE;
	m_ean8 = FALSE;
	m_upca = FALSE;
	m_upce = FALSE;
	m_39full = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CExampleDlg::~CExampleDlg()
{
	if (DibPtr != NULL) free(DibPtr);
	if (FrontDibPtr != NULL) free(FrontDibPtr);
	if (RearDibPtr != NULL) free(RearDibPtr);

}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
	DDX_Control(pDX, IDC_EDITLimitCharSet, m_ELimitCharSet);
	DDX_Control(pDX, IDC_CHECKLimitCharSet, m_CLimitCharSet);
	DDX_Control(pDX, IDC_COMBOMakeType, m_MakeType);
	DDX_Control(pDX, IDC_COMBOLoadType, m_LoadType);
	DDX_Control(pDX, IDC_CHECKDisplayImage, m_DisplayImage);
	DDX_Text(pDX, IDC_EDIT_H, m_h);
	DDX_Text(pDX, IDC_EDIT_W, m_w);
	DDX_Text(pDX, IDC_EDIT_X, m_x);
	DDX_Text(pDX, IDC_EDIT_Y, m_y);
	DDX_Text(pDX, IDC_Threshold, m_Threshold);
	DDX_Text(pDX, IDC_EDITLimitCharSet, m_CharSet);
	DDV_MaxChars(pDX, m_CharSet, 255);
	DDX_Check(pDX, IDC_CHECK_2_5_CHECK, m_25chk);
	DDX_Check(pDX, IDC_CHECK_3_9_CHECK, m_39chk);
	DDX_Check(pDX, IDC_CHECK_BC0, m_25i);
	DDX_Check(pDX, IDC_CHECK_BC1, m_39);
	DDX_Check(pDX, IDC_CHECK_BC2, m_128);
	DDX_Check(pDX, IDC_CHECK_BC3, m_93);
	DDX_Check(pDX, IDC_CHECK_BC4, m_ean13);
	DDX_Check(pDX, IDC_CHECK_BC5, m_ean8);
	DDX_Check(pDX, IDC_CHECK_BC6, m_upca);
	DDX_Check(pDX, IDC_CHECK_BC7, m_upce);
	DDX_Check(pDX, IDC_CHECK_BC8, m_39full);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBODirection, m_direction);
	DDX_Control(pDX, IDC_FRONT, Front_img);
	DDX_Control(pDX, IDC_REAR, Rear_img);
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_Read_Image, OnBUTTONReadImage)
	ON_BN_CLICKED(IDC_BUTTON_DLL_Version, OnBUTTONDLLVersion)
	ON_BN_CLICKED(IDC_BUTTONLoad, OnBUTTONLoad)
	ON_BN_CLICKED(IDC_BUTTONMakeOCR, OnBUTTONMakeOCR)
	ON_BN_CLICKED(IDC_BUTTONUnloadRecognizers, OnBUTTONUnloadRecognizers)
	ON_BN_CLICKED(IDC_BUTTON_SELECTWHOLEIMG, OnButtonSelectwholeimg)
	ON_BN_CLICKED(IDC_BUTTON_HELP, OnButtonHelp)
	ON_WM_CLOSE()
	ON_MESSAGE(WM_NULL, OnMyMessage)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTONMakeMH, &CExampleDlg::OnBnClickedButtonmakemh)
	ON_BN_CLICKED(IDC_FRONT_IMG, &CExampleDlg::OnBnClickedFrontImg)
	ON_BN_CLICKED(IDC_REAR_IMG, &CExampleDlg::OnBnClickedRearImg)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Add extra initialization here
	DibPtr = NULL;
	m_y = 570;
	m_x = 50;
	m_h = 70;
	m_w = 300;
	m_Threshold = 0;
	m_DisplayImage.SetCheck(1);

	m_25i = TRUE;
	m_39 = TRUE;
	m_128 = TRUE;
	m_93 = TRUE;
	m_ean13 = TRUE;
	m_ean8 = TRUE;
	m_upca = TRUE;
	m_upce = TRUE;
	m_upca = TRUE;
	m_39full = TRUE;
	m_25chk = FALSE;
	m_39chk = FALSE;

	DibPtr = NULL;
	FrontDibPtr = NULL;
	RearDibPtr = NULL;

	HOcr_SetEnv(ENV_INIFILENAME, "C:\\HHOOccrr.ini");

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


int CExampleDlg::Make(int type, int direction)
{
	int x, y, width, height;
	char str[1024];

	UpdateData(TRUE);
	ChangeSetup(CHANGE_UNREC_CHAR, '?');
	if(m_DisplayImage.GetCheck() == 1)
		ChangeSetup(CHANGE_DBG_MODE, DBG_SHOWDIB);
	else
		ChangeSetup(CHANGE_DBG_MODE, DBG_NO);
	if((m_Threshold >= 0) && (m_Threshold <= 200)){
		ChangeSetup(CHANGE_THRESHOLD, m_Threshold);
	}
	else{
		AfxMessageBox("Threshold out of limits");
		return FALSE;
	}
	x = m_x;
	y = m_y;
	width = m_w;
	height = m_h;
	if (DibPtr) {
		if (!MakeOCR_P(DibPtr, x, y, width, height, type, direction, str, sizeof(str))) {
			AfxMessageBox("recognition error");
			return FALSE;
		}
		MessageBox(str);
	}
	else{
		AfxMessageBox("Image not ready");
		return FALSE;
	}
	return TRUE;
}

void CExampleDlg::OnBUTTONDLLVersion() 
{
	CString vrsn;
	vrsn += GetRecoDllVersion();

	char *mac_addr = (char*)calloc(256, 1);
	sprintf_s(mac_addr, 256, "\n\n");
	getMAC(mac_addr, 256);
	vrsn += mac_addr;
	free(mac_addr);

	MessageBox(vrsn);	
}

void CExampleDlg::OnBUTTONLoad()
{
	UpdateData(TRUE);
	UINT Type;
	switch(m_LoadType.GetCurSel()){
		case 0: // OMNIFONT
				Type = TYPE_OMNIFONT;
			break;	
		case 1: //CMC7
				Type = TYPE_CMC7;
			break;	
		case 2: //E13B
				Type = TYPE_E13B;
			break;	
		case 3: //PDF417
				Type = TYPE_PDF417;
			break;	
		case 4: //BARCODE
				Type = TYPE_BARCODE;
			break;	
		case 5: //NUMERIC (special type)
				Type = TYPE_NUMERIC;
			break;	
		case 6: //DataMatrix
				Type = TYPE_DATAMATRIX;
			break;	
		case 7: //Micro Holes
				Type = TYPE_MICROHOLES;
			break;	
		default:
				AfxMessageBox("invalid Type");
			return;
	}

	if(!LoadRecognizer(Type))
		AfxMessageBox("Loading error");
	else {
		MessageBox("Loaded");
	}
}

void CExampleDlg::OnBUTTONUnloadRecognizers() 
{
	UnloadAllRecognizers();
}

void CExampleDlg::OnBUTTONMakeOCR() 
{
	UpdateData(TRUE);
	int Type, direction;

	switch(m_MakeType.GetCurSel()){
		case 0: // OMNIFONT
			Type = TYPE_OMNIFONT;
			if(m_CLimitCharSet.GetCheck() == 1)
				HOcrLimitCharset(m_CharSet); // limit charset
			else
				HOcrLimitCharset(""); // all charset
			break;	
		case 1: //CMC7
			Type = TYPE_CMC7;
			break;	
		case 2: //E13B
			Type = TYPE_E13B;
			break;	
		case 3: //PDF417
			Type = TYPE_PDF417;
			break;	
		case 4: //BARCODE
			Type = TYPE_BARCODE;
			char c[9];
			memset(c, '0', 9);
			if (m_25i)
				c[0] = '1';
			if (m_25chk)
				c[0] = '3';

			if (m_39)
				c[1] = '1';
			if (m_39chk)
				c[1] = '3';

			if (m_128)
				c[2] = '1';

			if (m_93)
				c[3] = '1';

			if (m_ean13)
				c[4] = '1';

			if (m_ean8)
				c[5] = '1';

			if (m_upca)
				c[6] = '1';

			if (m_upce)
				c[7] = '1';

			if (m_39full)
				c[8] = '1';
			if (m_39chk)
				c[8] = '3';

			if (!HOcrConfigBarcode(c)) {
				AfxMessageBox("Configuring Barcode error");
				return;
			}
			break;
		case 5:	//NUMERIC (special type)
			Type = TYPE_NUMERIC;
			break;
		case 6:	// Datamatrix
			Type = TYPE_DATAMATRIX;
			break;
		case 7:	// Micro Holes
			Type = TYPE_MICROHOLES;
			break;
		default:
			AfxMessageBox("invalid type");
			return;
	}
	switch (m_direction.GetCurSel()) {
		case 0: 
			direction = LEFT_RIGHT;
			break;
		case 1: 
			direction = RIGHT_LEFT;
			break;
		case 2: 
			direction = UP_DOWN;
			break;
		case 3: 
			direction = DOWN_UP;
			break;
		default:
			direction = 0;
			break;
	}
	Make(Type, direction);
}


void CExampleDlg::OnButtonSelectwholeimg() 
{
	PBITMAPINFOHEADER pDibInfo = (BITMAPINFOHEADER*)DibPtr;
	
	m_x = 0;
	m_y = 0;
	m_w = 10000;
	m_h = 10000;
	UpdateData(FALSE);
}

void CExampleDlg::OnBUTTONReadImage() 
{
	int	rc;
	long DibSize;

	CDialog::UpdateData(true);

	// Get FilePath
	CString FilePathName;
	CFileDialog		FileD(	true,			//BOOL bOpenFileDialog
							"bmp",			// LPCTSTR lpszDefExt = NULL
							".\\*.bmp",		// LPCTSTR lpszFileName = NULL
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_NONETWORKBUTTON | OFN_OVERWRITEPROMPT,		// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
							"BMP Files (*.bmp)|*.bmp|TIF Files (*.tif)|*.tif|All Files (*.*)|*.*||",		// LPCTSTR lpszFilter = NULL
							NULL);			// CWnd* pParentWnd = NULL

	rc = FileD.DoModal();
	if (rc != IDOK)
		return;
	FilePathName = FileD.GetPathName();

	// Load Dib from file

	char *tmpPtr = HOcrGetDibPtr(LPCTSTR(FilePathName), &DibSize);
	if (tmpPtr) {
		if (DibPtr != NULL) free(DibPtr);
		DibPtr = (char *)malloc(DibSize);
		if (DibPtr) {
			memcpy(DibPtr, tmpPtr, DibSize);
			if (DI.m_hWnd != NULL)
				DI.OnClose();
			DI.Create(IDD_DISPLAY_IMAGE, this);
			DI.loadDIB((HDIB)DibPtr);
			DI.LoadBitmapfromDIB((HDIB)DibPtr);
			DI.ShowWindow(SW_SHOWNORMAL);
		} else {
			MessageBox("Must be very low in memory!");
		}
	} else
		MessageBox("Read Image Fail");
}

void CExampleDlg::OnButtonHelp() 
{
	AfxGetApp()->WinHelp(0, HELP_CONTENTS);
}

void CExampleDlg::OnClose() 
{
	UnloadAllRecognizers();
	CDialog::OnClose();
}

////////////////////////////////////////////////////////////////////////////////
LRESULT CExampleDlg::OnMyMessage(WPARAM wParam, LPARAM lParam)
{
	m_x = (int)(((float)DI.FCurs.x / (float)DI.Dialog_DimX) * (float)DI.Image_DimX);
	// but since 0,0 on the window is top left while 0,0 on the image is bottom right
	m_x = DI.Image_DimX - m_x;
	// And now transform into Millimeters
	m_x = (m_x * 10000) / DI.Image_PixelxMeterX;
	// same for the rest
	m_y = (int)(((float)DI.FCurs.y / (float)DI.Dialog_DimX) * (float)DI.Image_DimX);
	m_y = DI.Image_DimY - m_y;
	m_y = (m_y * 10000) / DI.Image_PixelxMeterY;
	m_w = (int)(((float)(DI.FCurs.x - DI.ICurs.x) / (float)DI.Dialog_DimX) * (float)DI.Image_DimX);
	m_w = (m_w * 10000) / DI.Image_PixelxMeterX;
	m_h = (int)(((float)(DI.FCurs.y - DI.ICurs.y)  / (float)DI.Dialog_DimX) * (float)DI.Image_DimX);
	m_h = (m_h * 10000) / DI.Image_PixelxMeterY;

	UpdateData(FALSE);

	return NULL;
}

////////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnBnClickedButtonmakemh()
{
	int x, y, width, height;
	char str[1024];

	UpdateData(TRUE);
	ChangeSetup(CHANGE_UNREC_CHAR, '?');
	if(m_DisplayImage.GetCheck() == 1)
		ChangeSetup(CHANGE_DBG_MODE, DBG_SHOWDIB);
	else
		ChangeSetup(CHANGE_DBG_MODE, DBG_NO);
	if((m_Threshold >= 0) && (m_Threshold <= 200)){
		ChangeSetup(CHANGE_THRESHOLD, m_Threshold);
	}
	else{
		AfxMessageBox("Threshold out of limits");
		return;
	}
	x = m_x;
	y = m_y;
	width = m_w;
	height = m_h;
	if (!ValidateMH((UCHAR *)FrontDibPtr, (UCHAR *)RearDibPtr, x, y, width, height, (UCHAR *)str)) {
		AfxMessageBox("recognition error");
		return;
	}
	MessageBox(str);
	return;
}

////////////////////////////////////////////////////////////////////////////////
// Load Front Image
////////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnBnClickedFrontImg()
{
	int	rc;
	long DibSize;

	CDialog::UpdateData(true);

	// Get FilePath
	CString FilePathName;
	CFileDialog		FileD(	true,		//BOOL bOpenFileDialog
							"bmp",		// LPCTSTR lpszDefExt = NULL
							".\\*.bmp",		// LPCTSTR lpszFileName = NULL
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_NONETWORKBUTTON | OFN_OVERWRITEPROMPT,		// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
							"BMP Files (*.bmp)|*.bmp|TIF Files (*.tif)|*.tif|All Files (*.*)|*.*||",		// LPCTSTR lpszFilter = NULL
							NULL);		// CWnd* pParentWnd = NULL

	rc = FileD.DoModal();
	if (rc != IDOK)
		return;
	FilePathName = FileD.GetPathName();
	Front_img.SetWindowTextA(FilePathName);
	CDialog::UpdateData(false);
	// Load Dib from file
	char *tmpPtr = HOcrGetDibPtr(LPCTSTR(FilePathName), &DibSize);
	if (tmpPtr && DibSize) {
		if (FrontDibPtr != NULL) free(FrontDibPtr);
		FrontDibPtr = (char *)malloc(DibSize);
		if (FrontDibPtr) {
			memcpy(FrontDibPtr, tmpPtr, DibSize);
			if (FI.m_hWnd != NULL)
				FI.OnClose();
			FI.Create(IDD_DISPLAY_IMAGE, this);
			FI.loadDIB((HDIB)FrontDibPtr);
			FI.LoadBitmapfromDIB((HDIB)FrontDibPtr);
			FI.ShowWindow(SW_SHOWNORMAL);
		} else {
			MessageBox("Must be very low in memory!");
		}
	} else
		MessageBox("Read Image Fail");
}

////////////////////////////////////////////////////////////////////////////////
// Load Rear Image
////////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnBnClickedRearImg()
{
	int	rc;
	long DibSize;

	CDialog::UpdateData(true);

	// Get FilePath
	CString FilePathName;
	CFileDialog	FileD(	true,		//BOOL bOpenFileDialog
						"bmp",		// LPCTSTR lpszDefExt = NULL
						".\\*.bmp",		// LPCTSTR lpszFileName = NULL
						OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_NONETWORKBUTTON | OFN_OVERWRITEPROMPT,		// DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT
						"BMP Files (*.bmp)|*.bmp|TIF Files (*.tif)|*.tif|All Files (*.*)|*.*||",		// LPCTSTR lpszFilter = NULL
						NULL);		// CWnd* pParentWnd = NULL

	rc = FileD.DoModal();
	if (rc != IDOK)
		return;
	FilePathName = FileD.GetPathName();

	Rear_img.SetWindowTextA(FilePathName);
	CDialog::UpdateData(false);
	// Load Dib from file
	char *tmpPtr = HOcrGetDibPtr(LPCTSTR(FilePathName), &DibSize);
	if (tmpPtr && DibSize) {
		if (RearDibPtr != NULL) free(RearDibPtr);
		RearDibPtr = (char *)malloc(DibSize);
		if (RearDibPtr) {
			memcpy(RearDibPtr, tmpPtr, DibSize);
			if (RI.m_hWnd != NULL)
				RI.OnClose();
			RI.Create(IDD_DISPLAY_IMAGE, this);
			RI.loadDIB((HDIB)RearDibPtr);
			RI.LoadBitmapfromDIB((HDIB)RearDibPtr);
			RI.ShowWindow(SW_SHOWNORMAL);
		} else {
			MessageBox("Must be very low in memory!");
		}
	} else
		MessageBox("Read Image Fail");
}
